/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CategoriaOrgaoDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.entidad.CategoriaOrgao;
import com.rjconsultores.ventaboletos.service.CategoriaOrgaoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;


@Service("categoriaOrgaoService")
public class CategoriaOrgaoServiceImpl implements CategoriaOrgaoService {

    @Autowired
    private CategoriaOrgaoDAO categoriaOrgaoDAO;

    public List<CategoriaOrgao> obtenerTodos() {
        return categoriaOrgaoDAO.obtenerTodos();
    }

    public CategoriaOrgao obtenerID(Integer id) {
        return categoriaOrgaoDAO.obtenerID(id);
    }

    @Transactional
    public CategoriaOrgao suscribir(CategoriaOrgao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaOrgaoDAO.suscribir(entidad);
    }

    @Transactional
    public CategoriaOrgao actualizacion(CategoriaOrgao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaOrgaoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CategoriaOrgao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        categoriaOrgaoDAO.actualizacion(entidad);
    }

    public CategoriaOrgao busquedaPorCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        return categoriaOrgaoDAO.busquedaPorCategoriaCtrl(categoriaCtrl);
    }

	@Override
	@Transactional
	public void actualizacionAuditagem(List<CategoriaOrgao> lsCategoriaOrgao) {
		for (CategoriaOrgao cc : lsCategoriaOrgao) {
			if(Boolean.TRUE.equals(cc.getActivo())) {
				continue;
			}
			categoriaOrgaoDAO.actualizacion(cc);
		}
		
	}
}
